#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TherionIntegralCFG.h"
std::auto_ptr<Fish_TherionIntegralCFG> Fish_TherionIntegralCFG::msSingleton(nullptr);

int Fish_TherionIntegralCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionIntegralCFGData* Fish_TherionIntegralCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TherionIntegralCFGData>& Fish_TherionIntegralCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionIntegralCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TherionIntegralCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionIntegralCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mIntegralType = element->IntAttribute("IntegralType");
		data.mMinIntegral = element->IntAttribute("MinIntegral");
		data.mMaxIntegral = element->IntAttribute("MaxIntegral");
		data.mNewGiftWeight = element->IntAttribute("NewGiftWeight");
		data.mNewWeight = element->IntAttribute("NewWeight");
		data.mGiftWeight = element->IntAttribute("GiftWeight");
		data.mComWeight = element->IntAttribute("ComWeight");
		data.mNorWeight = element->IntAttribute("NorWeight");
		data.mOnListWeight = element->IntAttribute("OnListWeight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TherionIntegralCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionIntegralCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TherionIntegralCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TherionIntegralCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TherionIntegralCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "IntegralType", data.mIntegralType);
		LuaCfgHelper::readInt(L, "MinIntegral", data.mMinIntegral);
		LuaCfgHelper::readInt(L, "MaxIntegral", data.mMaxIntegral);
		LuaCfgHelper::readInt(L, "NewGiftWeight", data.mNewGiftWeight);
		LuaCfgHelper::readInt(L, "NewWeight", data.mNewWeight);
		LuaCfgHelper::readInt(L, "GiftWeight", data.mGiftWeight);
		LuaCfgHelper::readInt(L, "ComWeight", data.mComWeight);
		LuaCfgHelper::readInt(L, "NorWeight", data.mNorWeight);
		LuaCfgHelper::readInt(L, "OnListWeight", data.mOnListWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TherionIntegralCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionIntegralCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TherionIntegralCFG* Fish_TherionIntegralCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionIntegralCFG());
	}
	return msSingleton.get();
}

void Fish_TherionIntegralCFG::Release()
{
	msSingleton.reset(nullptr);
}
